> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Authenticate

> Authenticate with password using the Stytch Next.js SDK

The Authenticate method wraps the [Authenticate](/api-reference/consumer/api/passwords/authenticate) Password API endpoint. This endpoint verifies that the user has a password currently set, and that the entered password is correct. There are cases where this endpoint will return a `reset_password` error even if the password entered is correct. View our [API Docs](/api-reference/consumer/api/passwords/authenticate) for more information.

If this method succeeds, the user will be logged in, granted an active session, and the [session cookies](../../resources/cookies-and-session-management) will be minted and stored in the browser.

## Parameters

<ParamField body="email" type="string" required>
  The email of the user.
</ParamField>

<ParamField body="password" type="string" required>
  The password for the user. Any UTF8 character is allowed, e.g. spaces, emojis, non-English characters, etc.
</ParamField>

<ParamField body="session_duration_minutes" type="int" required>
  Set the session lifetime to be this many minutes from now. This will return both an opaque session\_token and session\_jwt for this session, which will automatically be stored either in the browser cookies if you're using our JavaScript SDK, or in the iOS Keychain/ Android SharedPreferences if you're using one of our mobile SDKs. The `session_jwt` will have a fixed lifetime of five minutes regardless of the underlying session duration, and will be automatically refreshed by the SDK in the background over time. This value must be a minimum of 5 and may not exceed the maximum session duration minutes value set in the [Frontend SDK page](https://stytch.com/dashboard/sdk-configuration) of the Stytch Dashboard. A successful authentication will continue to extend the session this many minutes.
</ParamField>

## Response

<ResponseField name="user_id" type="string">
  The unique ID of the affected User.
</ResponseField>

<ResponseField name="user" type="object">
  The user object affected by call.  See the [User object](/api-reference/consumer/api/users/user-object) for complete response field details.

  <Expandable title="properties">
    <ResponseField name="created_at" type="string">
      The timestamp of the User's creation. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
    </ResponseField>

    <ResponseField name="crypto_wallets" type="array[objects]">
      An array contains a list of all crypto wallets for a given User in the Stytch API.

      <Expandable title="properties">
        <ResponseField name="crypto_wallet_id" type="string">
          The unique ID for a crypto wallet
        </ResponseField>

        <ResponseField name="crypto_wallet_address" type="string">
          The actual blockchain address of the User's crypto wallet.
        </ResponseField>

        <ResponseField name="crypto_wallet_type" type="string">
          The blockchain that the User's crypto wallet operates on, e.g. Ethereum, Solana, etc.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="emails" type="array[objects]">
      An array of email objects for the User.

      <Expandable title="properties">
        <ResponseField name="email_id" type="string">
          The unique ID of a specific email address.
        </ResponseField>

        <ResponseField name="email" type="string">
          The email address.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="name" type="object">
      The name of the User. Each field in the name object is optional.

      <Expandable title="properties">
        <ResponseField name="first_name" type="string">
          The first name of the user.
        </ResponseField>

        <ResponseField name="middle_name" type="string">
          The middle name(s) of the user.
        </ResponseField>

        <ResponseField name="last_name" type="string">
          The last name of the user.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="trusted_metadata" type="object">
      The trusted\_metadata field contains an arbitrary JSON object of application-specific data. See the [Metadata](/api-reference/consumer/api/resources/metadata) reference for complete field behavior details.
    </ResponseField>

    <ResponseField name="untrusted_metadata" type="object">
      The untrusted\_metadata field contains an arbitrary JSON object of application-specific data. Untrusted metadata can be edited by end users directly via the SDK, and **cannot be used to store critical information.** See the [Metadata](/api-reference/consumer/api/resources/metadata) reference for complete field behavior details.
    </ResponseField>

    <ResponseField name="phone_numbers" type="array[objects]">
      An array of phone number objects linked to the User.

      <Expandable title="properties">
        <ResponseField name="phone_id" type="string">
          The unique ID for the phone number.
        </ResponseField>

        <ResponseField name="phone_number" type="string">
          The phone number.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="providers" type="array[objects]">
      An array of OAuth provider objects linked to the User.

      <Expandable title="properties">
        <ResponseField name="oauth_user_registration_id" type="string">
          The unique ID for an OAuth registration.
        </ResponseField>

        <ResponseField name="provider_subject" type="string">
          The unique identifier for the User within a given OAuth provider. Also commonly called the "sub" or "Subject field" in OAuth protocols.
        </ResponseField>

        <ResponseField name="provider_type" type="string">
          Denotes the OAuth identity provider that the user has authenticated with, e.g. Google, Facebook, GitHub etc.
        </ResponseField>

        <ResponseField name="profile_picture_url" type="string">
          If available, the profile\_picture\_url is a url of the User's profile picture set in OAuth identity the provider that the User has authenticated with, e.g. Facebook profile picture.
        </ResponseField>

        <ResponseField name="locale" type="string">
          If available, the locale is the User's locale set in the OAuth identity provider that the user has authenticated with.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="password" type="object">
      The password object is returned for users with a password.

      <Expandable title="properties">
        <ResponseField name="password_id" type="string">
          The unique ID of a specific password
        </ResponseField>

        <ResponseField name="requires_reset" type="boolean">
          Indicates whether this password requires a password reset
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="status" type="string">
      The status of the User. The possible values are `pending` and `active`.
    </ResponseField>

    <ResponseField name="totps" type="array[objects]">
      An array containing a list of all TOTP instances for a given User in the Stytch API.

      <Expandable title="properties">
        <ResponseField name="totp_id" type="string">
          The unique ID for a TOTP instance.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="user_id" type="string">
      The unique ID of the affected User.
    </ResponseField>

    <ResponseField name="webauthn_registrations" type="array[objects]">
      An array that contains a list of all Passkey or WebAuthn registrations for a given User in the Stytch API.

      <Expandable title="properties">
        <ResponseField name="webauthn_registration_id" type="string">
          The unique ID for the Passkey or WebAuthn registration.
        </ResponseField>

        <ResponseField name="domain" type="string">
          The domain on which Passkey or WebAuthn registration was started. This will be the domain of your app.
        </ResponseField>

        <ResponseField name="user_agent" type="string">
          The user agent of the User.
        </ResponseField>

        <ResponseField name="authenticator_type" type="string">
          The authenticator\_type string displays the requested authenticator type of the Passkey or WebAuthn device. The two valid types are "platform" and "cross-platform". If no value is present, the Passkey or WebAuthn device was created without an authenticator type preference.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>

        <ResponseField name="name" type="string">
          The name of the Passkey or WebAuthn registration.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="biometric_registrations" type="array[objects]">
      An array that contains a list of all biometric registrations for a given User in the Stytch API.

      <Expandable title="properties">
        <ResponseField name="biometric_registration_id" type="string">
          The unique ID for a biometric registration.
        </ResponseField>

        <ResponseField name="verified" type="boolean">
          If this method has been successfully authenticated by the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="roles" type="array[strings]">
      Roles assigned to this User. See the [RBAC guide](/consumer-auth/authorization/assigning-roles-to-users) for more information about role assignment.
    </ResponseField>
  </Expandable>
</ResponseField>

<ResponseField name="session_token" type="string">
  A secret token for a given Stytch Session.
</ResponseField>

<ResponseField name="session_jwt" type="string">
  The JSON Web Token (JWT) for a given Stytch Session.
</ResponseField>

<ResponseField name="session" type="object">
  If you initiate a Session, by including session\_duration\_minutes in your authenticate call, you'll receive a full Session object in the response. See [Session object](/api-reference/consumer/api/sessions/session-object) for complete response fields.

  <Expandable title="properties">
    <ResponseField name="session_id" type="string">
      A unique identifier for a specific Session.
    </ResponseField>

    <ResponseField name="user_id" type="string">
      The unique ID of the affected User.
    </ResponseField>

    <ResponseField name="authentication_factors" type="array[objects]">
      An array of different authentication factors that comprise a Session.
    </ResponseField>

    <ResponseField name="started_at" type="string">
      The timestamp when the Session was created. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
    </ResponseField>

    <ResponseField name="last_accessed_at" type="string">
      The timestamp when the Session was last accessed. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
    </ResponseField>

    <ResponseField name="expires_at" type="string">
      The timestamp when the Session expires. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
    </ResponseField>

    <ResponseField name="attributes" type="object">
      Provided attributes help with fraud detection.

      <Expandable title="properties">
        <ResponseField name="ip_address" type="string">
          The IP address of the user.
        </ResponseField>

        <ResponseField name="user_agent" type="string">
          The user agent of the User.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="custom_claims" type="map">
      The custom claims map for a Session. Claims can be added to a session during a Sessions authenticate call.
    </ResponseField>

    <ResponseField name="roles" type="array[string]">
      A list of the roles associated with the session.
    </ResponseField>
  </Expandable>
</ResponseField>

<ResponseField name="user_device" type="object">
  If [Protected Auth](/fraud-risk/device-fingerprinting/protected-auth) is enabled and returned fingerprinting results, the user\_device response field will contain information about the user's device attributes.

  <Expandable title="properties">
    <ResponseField name="ip_address" type="string">
      The IP address of the user's device.
    </ResponseField>

    <ResponseField name="ip_address_details" type="object">
      Information about the ip\_address.

      <Expandable title="properties">
        <ResponseField name="is_new" type="boolean">
          Whether this ip\_address has been seen before for this user.
        </ResponseField>

        <ResponseField name="first_seen_at" type="string">
          When this ip\_address was first seen for this user. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
        </ResponseField>

        <ResponseField name="last_seen_at" type="string">
          When this ip\_address was last seen for this user. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="ip_geo_country" type="string">
      The country code where the IP address is located.
    </ResponseField>

    <ResponseField name="ip_geo_country_details" type="object">
      Information about the ip\_geo\_country.

      <Expandable title="properties">
        <ResponseField name="is_new" type="boolean">
          Whether this ip\_geo\_country has been seen before for this user.
        </ResponseField>

        <ResponseField name="first_seen_at" type="string">
          When this ip\_geo\_country was first seen for this user. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
        </ResponseField>

        <ResponseField name="last_seen_at" type="string">
          When this ip\_geo\_country was last seen for this user. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="ip_geo_city" type="string">
      The city where the IP address is located.
    </ResponseField>

    <ResponseField name="ip_geo_region" type="string">
      The region where the IP address is located.
    </ResponseField>
  </Expandable>
</ResponseField>

<ResponseField name="request_id" type="string">
  Globally unique UUID that is returned with every API call. This value is important to log for debugging purposes; we
  may ask for this value to help identify a specific API call when helping you debug an issue.
</ResponseField>

<ResponseField name="status_code" type="number">
  The HTTP status code of the response. Stytch follows standard HTTP response status code patterns, e.g. 2XX values
  equate to success, 3XX values are redirects, 4XX are client errors, and 5XX are server errors.
</ResponseField>

<Panel>
  <RequestExample>
    ```jsx theme={null}
    import { useCallback } from 'react';
    import { useStytch } from '@stytch/nextjs';

    export const Login = () => {
    const stytch = useStytch();

    const authenticatePassword = useCallback(() => {
      stytch.passwords.authenticate({
        email: '${exampleEmail}',
        password: '${examplePassword}',
        session_duration_minutes: 60,
      });
    }, [stytch]);

    return <button onClick={authenticatePassword}>Authenticate Password</button>;
    };
    ```
  </RequestExample>

  <ResponseExample>
    ```json 200 theme={null}
    {
        "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
        "session": null,
        "session_jwt": "",
        "session_token": "",
        "status_code": 200,
        "user": {...},
        "user_id": "user-test-16d9ba61-97a1-4ba4-9720-b03761dc50c6",
    }
    ```

    ```json 401 theme={null}
    {
      "status_code": 401,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "unauthorized_credentials",
      "error_message": "Unauthorized credentials.",
      "error_url": "https://stytch.com/docs/api/errors/401"
    }
    ```

    ```json 404 theme={null}
    {
      "status_code": 404,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "email_not_found",
      "error_message": "Email could not be found.",
      "error_url": "https://stytch.com/docs/api/errors/404"
    }
    ```

    ```json 429 theme={null}
    {
      "status_code": 429,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "too_many_requests",
      "error_message": "Too many requests have been made.",
      "error_url": "https://stytch.com/docs/api/errors/429"
    }
    ```

    ```json 500 theme={null}
    {
      "status_code": 500,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "internal_server_error",
      "error_message": "Oops, something seems to have gone wrong, please reach out to support@stytch.com to let us know what went wrong.",
      "error_url": "https://stytch.com/docs/api/errors/500"
    }
    ```
  </ResponseExample>
</Panel>
